/******************************************************************************
* Anzeigen von /etc/hosts																	   *
******************************************************************************/

/* Die Includes werden gemacht */
/*---------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <support.h>
#include "util.h"

/*---------------------------------------------------------------------------*/

void print_host(void) {
	char					host[HOSTNAME_LEN]; /* Hier wird der mit gethostname()
	                                         ermittelte Hostname gespeichert */
	int  					dummy;              /* Wird verwendet wenn ein Funktions-
	                                         ergebnis uninteressant ist */
	char					buf[MAXLINE];		  /* Hier wird eine aus /etc/passwd
	                                         gelesene Zeile gespeichert */
	char					*buf_ptr;			  /* Pointer, der beim zerlegen von buf
	                                         benoetigt wird */
	struct structHost	*host_base=NULL;
	struct structHost  *akt;
	int					x;
	
	
	x=read_hosts(&host_base);
	if (DEBUG) printf("print_hosts: Ergebnis von read_hosts: %d<br>\n",x);
	dummy=gethostname(host,HOSTNAME_LEN);
	/*Die HTML-Tabelle wird erstellt*/
	printf("<center><h2>Rechnerliste auf %s</h2>\n",host);
	printf("<table border>\n");
	
	/*Tabellen&uuml;berschriften*/
	printf("<tr>\n");
		printf("<td valign=top>\n");
			printf("<strong>IP-Nummer</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Namen</strong>\n");
		printf("</td>\n");
	printf("</tr>\n");

	if (host_base != NULL) {
		akt = host_base;
		do {
			printf("<tr>\n");
			printf("<td valign=top>%s</td>\n",akt->ip);
			printf("<td valign=top>%s</td>\n",akt->names);
			
			printf("</tr>\n");
			akt = akt->next;			
		} while(akt != host_base);
	}	
	
	/*Die Tabelle wird beendet*/
	printf("</table></center>\n");
}


/* In main wird die HTML-Ausgabe initialisiert und alles gesteuert */
/*---------------------------------------------------------------------------*/

int main()
{
	/*Die Menues etc, die ueberall gleich sind werden ausgegeben*/
	header(RECHNERLISTE,"Rechner und IP-Nummern");
	
	/*Das Eingabeformular fuer neue Rechner ausgeben*/
	printf("<center>\n"
			 "<form action=\"/admin-bin/hosts_man.html\" method=post>\n"
			 "<table border>\n"
				"<tr>\n"
					"<td align=right valign=top>\n"
						"<strong><big>IP Nummer:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"ip1\" type=text size=3 maxlength=3><big>.</big>" 
						"<input name=\"ip2\" type=text size=3 maxlength=3><big>.</big>" 
						"<input name=\"ip3\" type=text size=3 maxlength=3><big>.</big>" 
						"<input name=\"ip4\" type=text size=3 maxlength=3>\n" 
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Rechnername</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"name\" type=text size=32 maxlength=128>\n" 
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td align=right valign=top>\n"
						"<strong><big>zus&auml;tzliche Namen, durch Leerzeichen getrennt</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"addnames\" type=text size=64 maxlength=255>\n" 
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td valign=top align=right>\n"
						"<strong><big>Aktion:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<select name=\"action\" size=2>\n"
							"<option selected>eintragen\n"
							"<option>entfernen\n"
						"</select>\n"
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td colspan=2>\n"
						"<ul>\n"
						"<li><strong>Wenn im Netzwerk kein Domainname-Server vorhanden ist, kann es fuer manche TCP/IP-Clients"
						" (z.B. Netscape Mail) notwendig sein, den Rechner mit seinem Namen und zus&auml;tzlich mit seinem Namen mit angeh&auml;ngter Domain einzutragen."
						" Beispiel: name: kermit, zusaetzlicher Name: kermit.muppet.de, wobei muppet.de dann die Domain des Rechners w&auml;re.</strong><br>\n"
					   "<li><strong>Eintragen:</strong>Notwendig ist die IP-Nummer (s. Dokumentation) und der Rechnername.<br>\n"
						"<li><strong>Entfernen:</strong>Nur die IP-Nummer wird beachtet.<br>\n"
						"</ul>\n"
					"</td>\n"
				"</tr>\n"
			"</table>\n"
			"<p>\n"
			"<input type=submit value=\"Aktion ausf&uuml;hren\">\n"
			"</form>\n");
   printf("<hr>\n");
	printf("</center>\n");
								
	print_host();
	
	if (DEBUG) printf("Nach der Ausgabe der Tabelle<br>\n");
	
	/*Tail gibt das bei allen Seiten gleiche Ende der HTML-Anzeige aus*/
	tail();
	
	return 0;
}
