/******************************************************************************
* Dieses Programm dient zum Auslesen  der Informationen in                    *
* /etc/passwd mithilfe eines cgi-faehigen web-servers und eines Web-Browsers  *
******************************************************************************/

/* Die Includes werden gemacht */
/*---------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <support.h>
#include "util.h"

/* print_filesys() oeffnet /etc/fstab und gibt den Inhalt als HTML-Tabelle aus*/
/*---------------------------------------------------------------------------*/

void print_import(void) {
	FILE					*fstab_conv_file;	  /* file-handle fuer das konvertierte 
															fstab*/
	char					host[HOSTNAME_LEN]; /* Hier wird der mit gethostname()
	                                         ermittelte Hostname gespeichert */
	int  					dummy;              /* Wird verwendet wenn ein Funktions-
	                                         ergebnis uninteressant ist */
	char					buf[MAXLINE];		  /* Hier wird eine aus /etc/passwd
	                                         gelesene Zeile gespeichert */
	char					*buf_ptr;			  /* Pointer, der beim zerlegen von buf
	                                         benoetigt wird */
	char					server[MAXLINE];	   /* zu mountendes Drive */
	char					serverpath[MAXLINE];
	char					mountpoint[MAXLINE];	/* Mountpoint */
	char					type[MAXLINE];			/* Typ des fs */
	int					blocksize;		/* Name des Besitzers */
	int					retries;		/* Name der Gruppe */
	char					dummy_str[MAXLINE];  /* unwichtige Strings */
	struct structImport	*import_base=NULL;
	struct structImport  *akt;
	int					x;
	
	
	read_imports(&import_base);

	dummy=gethostname(host,HOSTNAME_LEN);
	/*Die HTML-Tabelle wird erstellt*/
	printf("<center><h2>Importierte Dateisysteme auf %s</h2>\n",host);
	printf("<table border>\n");
	
	/*Tabellen&uuml;berschriften*/
	printf("<tr>\n");
		printf("<td valign=top>\n");
			printf("<strong>Server</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Pfad des exportierten Verzeichnisses</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Lokaler Name im Verzeichnis <pre>u:\\nfs\\</pre></strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Typ des Imports</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>max. Blockgr&ouml;&szlig;e</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Wdh. bei Fehler</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Status</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Wiederherstellen bei Neustart</strong>\n");
		printf("</td>\n");
	printf("</tr>\n");

	if (import_base != NULL) {
		akt = import_base;
		do {
			printf("<tr>\n");
			printf("<td><pre>%s</pre></td>\n",akt->server);
			printf("<td><pre>%s</pre></td>\n",akt->serverpath);
			x=5;
			for (x = 5 ; x <= strlen(akt->mountpoint) ; x++)
				dummy_str[x-5]=akt->mountpoint[x];
			printf("<td><pre>%s</pre></td>\n",dummy_str);
			printf("<td align=center><pre>%s</pre></td>\n",akt->type);
			printf("<td align=center><pre>%d</pre></td>\n",akt->blocksize);
			printf("<td align=center><pre>%d</pre></td>\n",akt->retries);
			
			if (akt->mounted) {
				printf("<td align=center><pre>aktiv</pre></td>\n");
			} else {
				printf("<td align=center><pre>nicht&nbsp;aktiv</pre></td>\n");
			}
			
			if (akt->bootloaded) {
				printf("<td align=center><pre>ja</pre></td>\n");
			} else {
				printf("<td align=center><pre>nein</pre></td>\n");
			}
			
			printf("</tr>\n");
			akt = akt->next;			
		} while(akt != import_base);
	}	
	
	/*Die Tabelle wird beendet*/
	printf("</table></center>\n");
}


/* In main wird die HTML-Ausgabe initialisiert und alles gesteuert */
/*---------------------------------------------------------------------------*/

int main()
{
	/*Die Menues etc, die ueberall gleich sind werden ausgegeben*/
	header(IMPORT,"Importierte Netzlaufwerke");
	
	/*Das Eingabeformular fuer neue Dateisysteme ausgeben*/
	printf("<center>\n"
			 "<form action=\"/admin-bin/import_man.html\" method=post>\n"
			 "<table border>\n"
				"<tr>\n"
					"<td align=right valign=top colspan=2>\n"
						"<strong><big>Name des Imports:</big></strong>\n"
					"</td>\n"
					"<td valign=top colspan=2>\n"
						"<input name=\"mountpoint\" type=text size=12 maxlength=32>\n" 
					"</td>\n"
					"<td align=right valign=top>\n"
						"<strong><big>autom. verbinden</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input type=checkbox name=\"bootflag\" value=\"bootflag\">\n"
					"</td>\n"					
				"</tr>\n"
				"<tr>\n"
					"<td align=right valign=top colspan=2>\n"
						"<strong><big>Name des Servers:</big></strong>\n"
					"</td>\n"
					"<td valign=top colspan=2>\n"
						"<input name=\"server\" type=text size=16 maxlength=64>\n"
					"</td>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Exportierter Pfad</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"serverpath\" type=text size=16 maxlength=128>\n" 
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td valign=top align=right>\n"
						"<strong><big>Blockgr&ouml;&szlig;e:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<select name=\"blocksize\" size=3>\n"
							"<option selected>keine Angabe\n"
							"<option>1024\n"
							"<option>2048\n"
							"<option>4096\n"
							"<option>8192\n"
						"</select>\n"
					"</td>\n"
					"<td valign=top align=right>\n"
						"<strong><big>Wdh bei Fehler:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<select name=\"retries\" size=3>\n"
							"<option selected>keine Angabe\n"
							"<option>3\n"
							"<option>4\n"
							"<option>5\n"
							"<option>6\n"
							"<option>7\n"
							"<option>8\n"
							"<option>9\n"
							"<option>10\n"
						"</select>\n"
					"</td>\n"
					"<td valign=top align=right>\n"
						"<strong><big>Aktion:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<select name=\"action\" size=3>\n"
							"<option selected>verbinden\n"
							"<option>entfernen\n"
							"<option>aktualisieren\n"
						"</select>\n"
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td colspan=6>\n"
						"<ul>\n"
						"<li><strong>Mit Ausnahme der Aktion \"verbinden\" wirken alle Aktionen erst nach einem Neustart des Systems.</strong><br>\n"
					   "<li><strong>Wenn sie einen Import dessen Wiederherstellung w&auml;hrend der Startphase fehlschlug verbinden wollen,"
					                "dann geben sie nur den Namen des Imports an und w&auml;hlen sie die Aktion verbinden aus. Andere Parameter werden in "
					                "diesem Fall nicht beachtet.</strong><br>\n"
					   "<li><strong>Eintragen:</strong> Notwendig sind Servername, Pfad des Exports auf dem Server und der Name des Imports (als Verzeichnis in u:\\nfs).<br>\n"
						"<li><strong>Entfernen:</strong> Es wird nur der Name des Imports beachtet.<br>\n"
						"<li><strong>Aktualisieren:</strong> Notwendig ist der Name des Imports, sonst bitte nur die zu &auml;ndernden Felder ausf&uuml;llen."
						"der Name selbst kann nicht ge&auml;ndert werden, um eine Namens&auml;nderung vorzunehmen mu&szlig; das Laufwerk neu verbunden werden<br>\n"
						"</ul>\n"
					"</td>\n"
				"</tr>\n"
			"</table>\n"
			"<p>\n"
			"<input type=submit value=\"Aktion ausf&uuml;hren\">\n"
			"</form>\n");
   printf("<hr>\n");
	printf("</center>\n");
								
	/*print_filesys erstellt aus /etc/fstab eine HTML-Tabelle
	  und zeigt die eingetragenen lokalen Dateisysteme an*/
	print_import();
	
	if (DEBUG) printf("Nach der Ausgabe der Tabelle<br>\n");
	
	/*Tail gibt das bei allen Seiten gleiche Ende der HTML-Anzeige aus*/
	tail();
	
	return 0;
}
