/******************************************************************************
* Anzeigen von /etc/config.if																   *
******************************************************************************/

/* Die Includes werden gemacht */
/*---------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <support.h>
#include "util.h"


/*---------------------------------------------------------------------------*/
void common_config(void){

	char					host[HOSTNAME_LEN]; /* Hier wird der mit gethostname()
	                                         ermittelte Hostname gespeichert */
	int  					dummy;              /* Wird verwendet wenn ein Funktions-
	                                         ergebnis uninteressant ist */
	char					dummy_str[MAXLINE];
	char					buf[MAXLINE];
	char					domain[MAXLINE];
	char					*dns[3];
	char					dns11[5];
	char					dns12[5];
	char					dns13[5];
	char					dns14[5];
	char					dns21[5];
	char					dns22[5];
	char					dns23[5];
	char					dns24[5];
	char					dns31[5];
	char					dns32[5];
	char					dns33[5];
	char					dns34[5];
	char					workgroup[MAXLINE];
	char					smbguest[MAXLINE];
	char					gw[20];
	char					gw1[5];
	char					gw2[5];
	char					gw3[5];
	char					gw4[5];
	int					i;
	FILE					*helpfile;



	for (i=0;i<3;i++) {
		dns[i] = (char *) malloc(sizeof(char)*MAXLINE);
		strcpy(dns[i],"");
	}
	strcpy(dns11,"");strcpy(dns12,"");strcpy(dns13,"");strcpy(dns14,"");
	strcpy(dns21,"");strcpy(dns22,"");strcpy(dns23,"");strcpy(dns24,"");
	strcpy(dns31,"");strcpy(dns32,"");strcpy(dns33,"");strcpy(dns34,"");
	strcpy(gw1,"");strcpy(gw2,"");strcpy(gw3,"");strcpy(gw4,"");


	dummy=gethostname(host,HOSTNAME_LEN);
	system(GETDOMAIN_CMD);
	helpfile=fopen(DOMAIN_FILE,"r");
	strcpy(buf,"");
	fgets(buf,MAXLINE,helpfile);
	getword(domain,buf,'\n');
	fclose(helpfile);

	system(GETDNS_CMD);
	helpfile=fopen(DNS_FILE,"r");
	strcpy(buf,"");
	fgets(buf,MAXLINE,helpfile);
	if (!feof(helpfile)) {
		getword(dns[0],buf,'\n');
		strcpy(dummy_str,dns[0]);
		getword(dns11,dummy_str,'.');
		getword(dns12,dummy_str,'.');
		getword(dns13,dummy_str,'.');
		getword(dns14,dummy_str,'.');
	}
	strcpy(buf,"");
	fgets(buf,MAXLINE,helpfile);
	if (!feof(helpfile)) {
		getword(dns[1],buf,'\n');
		strcpy(dummy_str,dns[1]);
		getword(dns21,dummy_str,'.');
		getword(dns22,dummy_str,'.');
		getword(dns23,dummy_str,'.');
		getword(dns24,dummy_str,'.');
	}
	strcpy(buf,"");
	fgets(buf,MAXLINE,helpfile);
	if (!feof(helpfile)) {
		getword(dns[2],buf,'\n');
		strcpy(dummy_str,dns[2]);
		getword(dns31,dummy_str,'.');
		getword(dns32,dummy_str,'.');
		getword(dns33,dummy_str,'.');
		getword(dns34,dummy_str,'.');
	}
	fclose(helpfile);

	helpfile=fopen(SMBWRK_NAME,"r");
	strcpy(buf,"");
	fgets(buf,MAXLINE,helpfile);
	getword(dummy_str,buf,'=');
	getword(workgroup,buf,'\n');
	fclose(helpfile);

	helpfile=fopen(SMBGST_NAME,"r");
	strcpy(buf,"");
	fgets(buf,MAXLINE,helpfile);
	getword(dummy_str,buf,'=');
	getword(smbguest,buf,'\n');
	fclose(helpfile);

	helpfile=fopen(GW_NAME,"r");
	strcpy(buf,"");
	fgets(buf,MAXLINE,helpfile);
	getword(dummy_str,buf,' ');
	getword(gw,buf,'\n');
	fclose(helpfile);
	strcpy(dummy_str,gw);
	getword(gw1,dummy_str,'.');
	getword(gw2,dummy_str,'.');
	getword(gw3,dummy_str,'.');
	getword(gw4,dummy_str,'.');


	printf("<center>\n"
			 "<h2>Rechneridentifikation und Netzwerkeinstellungen</h2>\n"
			 "<form action=\"/admin-bin/cnet_man.html\" method=post>\n"
			 "<table border>\n"
				"<tr>\n"
					"<td valign=top align=right>\n"
						"<strong><big>Rechnername:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"name\" value=\"%s\" type=text size=16 maxlength=32>",host); 
			printf("</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td valign=top align=right>\n"
						"<strong><big>Dom&auml;ne:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"domain\" value=\"%s\" type=text size=40 maxlength=128>",domain); 
			printf("</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Erster Nameserver:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n");
						printf("<input name=\"dns11\" value=\"%s\" type=text size=3 maxlength=3><big>.</big>",dns11); 
						printf("<input name=\"dns12\" value=\"%s\" type=text size=3 maxlength=3><big>.</big>",dns12); 
						printf("<input name=\"dns13\" value=\"%s\" type=text size=3 maxlength=3><big>.</big>",dns13); 
						printf("<input name=\"dns14\" value=\"%s\" type=text size=3 maxlength=3>\n",dns14);
			printf("</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Zweiter Nameserver:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n");
						printf("<input name=\"dns21\" value=\"%s\" type=text size=3 maxlength=3><big>.</big>",dns21); 
						printf("<input name=\"dns22\" value=\"%s\" type=text size=3 maxlength=3><big>.</big>",dns22); 
						printf("<input name=\"dns23\" value=\"%s\" type=text size=3 maxlength=3><big>.</big>",dns23); 
						printf("<input name=\"dns24\" value=\"%s\" type=text size=3 maxlength=3>\n",dns24);
			printf("</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Dritter Nameserver:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n");
						printf("<input name=\"dns31\" value=\"%s\" type=text size=3 maxlength=3><big>.</big>",dns31); 
						printf("<input name=\"dns32\" value=\"%s\" type=text size=3 maxlength=3><big>.</big>",dns32); 
						printf("<input name=\"dns33\" value=\"%s\" type=text size=3 maxlength=3><big>.</big>",dns33); 
						printf("<input name=\"dns34\" value=\"%s\" type=text size=3 maxlength=3>\n",dns34);
			printf("</td>\n"
				"</tr>\n"
				"</tr>\n"
				"<tr>\n"
					"<td valign=top align=right>\n"
						"<strong><big>Windows-Arbeitsgruppe oder -Dom&auml;ne:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"workgroup\" value=\"%s\" type=text size=16 maxlength=32>",workgroup); 
			printf("</td>\n"
				"</tr>\n"
				"</tr>\n"
				"<tr>\n"
					"<td valign=top align=right>\n"
						"<strong><big>Benutzerkennung f&uuml;r unbekannte Benutzer bei Windows-kompatiblen Exporten</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"smbguest\" value=\"%s\" type=text size=16 maxlength=32>",smbguest); 
			printf("</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Default-Gateway:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n");
						printf("<input name=\"gw1\" value=\"%s\" type=text size=3 maxlength=3><big>.</big>",gw1); 
						printf("<input name=\"gw2\" value=\"%s\" type=text size=3 maxlength=3><big>.</big>",gw2); 
						printf("<input name=\"gw3\" value=\"%s\" type=text size=3 maxlength=3><big>.</big>",gw3); 
						printf("<input name=\"gw4\" value=\"%s\" type=text size=3 maxlength=3>\n",gw4);
			printf("</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td colspan=2>\n"
						"<ul>\n"
						"<li><strong>Die voreingestellten Werte repr&auml;sentieren die aktuellen Einstellungen.</strong><br>\n"
						"</ul>\n"
					"</td>\n"
				"</tr>\n"
			"</table>\n"
			"<p>\n"
			"<input type=submit value=\"Eintragen\">\n"
			"</form>\n");
   printf("<hr><hr>\n");
	printf("</center>\n");
}




/*---------------------------------------------------------------------------*/
void passwd_set(void){

	printf("<center>\n"
			 "<h2>Passwort f&uuml;r Rechneradministration</h2>\n"
			 "<form action=\"/admin-bin/access_man.html\" method=post>\n"
			 "<table border>\n"
				"<tr>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Passwort:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"password\" type=password size=10 maxlength=15>\n" 
					"</td>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Passwort (Wdh.)</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"vpassword\" type=password size=10 maxlength=15>\n" 
					"</td>\n"
				"</tr>\n"
			"</table>\n"
			"<p>\n"
			"<input type=submit value=\"Passwort setzen\">\n"
			"</form>\n");
   printf("<hr><hr>\n");
	printf("</center>\n");
}



/*---------------------------------------------------------------------------*/
void print_confif(void) {
	char					host[HOSTNAME_LEN]; /* Hier wird der mit gethostname()
	                                         ermittelte Hostname gespeichert */
	int  					dummy;              /* Wird verwendet wenn ein Funktions-
	                                         ergebnis uninteressant ist */
	char					buf[MAXLINE];		  /* Hier wird eine aus /etc/passwd
	                                         gelesene Zeile gespeichert */
	char					*buf_ptr;			  /* Pointer, der beim zerlegen von buf
	                                         benoetigt wird */
	struct structConfIf	*confif_base=NULL;
	struct structConfIf  *akt;
	int					x;
	
	
	x=read_confIf(&confif_base);
	if (DEBUG) printf("print_confif: Ergebnis von read_confif: %d<br>\n",x);
	dummy=gethostname(host,HOSTNAME_LEN);
	/*Die HTML-Tabelle wird erstellt*/
	printf("<center><h2>Konfigurierte Netzwerk-Anschl&uuml;sse auf %s</h2>\n",host);
	printf("<table border>\n");
	
	/*Tabellen&uuml;berschriften*/
	printf("<tr>\n");
		printf("<td valign=top>\n");
			printf("<strong>Anschlu&szlig;</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>IP-Nummer</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Netzwerk</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Netzmaske</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Broadcast-Adresse</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Hardware-Adresse</strong>\n");
		printf("</td>\n");
	printf("</tr>\n");

	if (confif_base != NULL) {
		akt = confif_base;
		do {
			printf("<tr>\n");
			printf("<td valign=top>%s</td>\n",akt->intrfc);
			printf("<td valign=top>%s</td>\n",akt->ip);
			printf("<td valign=top>%s</td>\n",akt->network);
			printf("<td valign=top>%s</td>\n",akt->netmask);
			printf("<td valign=top>%s</td>\n",akt->broadcast);
			if (strlen(akt->hwaddr)) printf("<td valign=top>%s</td>\n",akt->hwaddr);
			else printf("<td valign=top>nicht notwendig</td>\n");
			
			printf("</tr>\n");
			akt = akt->next;			
		} while(akt != confif_base);
	}	
	
	/*Die Tabelle wird beendet*/
	printf("</table></center>\n");
}




/* In main wird die HTML-Ausgabe initialisiert und alles gesteuert */
/*---------------------------------------------------------------------------*/

int main()
{
	FILE	*ifavail_file;
	char	buf[MAXLINE];
	char	intrfc[MAXLINE];
	char	intrfc_full[MAXLINE];
	int	intrfc_len;
	struct structConfIf *confIf_base=NULL;
	struct structConfIf *akt_confIf=NULL;

	/*Die Menues etc, die ueberall gleich sind werden ausgegeben*/
	header(NETZWERK,"Netzwerkanschl&uuml;sse und Rechneridentifikation");

	/*Das Formular fuer Allgemeine Konfiguration*/
	common_config();

	passwd_set();
	
	/*Das Eingabeformular fuer Interface-Config ausgeben*/
	printf("<center>\n"
			 "<h2>Netzwerkanschl&uuml;sse</h2>\n"
			 "<form action=\"/admin-bin/intrfc_man.html\" method=post>\n"
			 "<table border>\n"
				"<tr>\n"
					"<td valign=top align=right>\n"
						"<strong><big>Netzanschlu&szlig;:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<select name=\"ifname\" size=3>\n");
							read_confIf(&confIf_base);
							system(GETIF_CMD);
							ifavail_file=fopen(IFAVAIL_FILE,"r");
							while(!feof(ifavail_file)) {				
								fgets(buf,MAXLINE,ifavail_file);
								if (!feof(ifavail_file)) {
									getword(intrfc,buf,'\n');
									intrfc_len=strlen(intrfc);
									strcpy(intrfc_full,intrfc);
									intrfc[intrfc_len-1]='\0';
									if (!strcmp(intrfc,"ne")) printf("<option>%s (ne2000)\n",intrfc_full);
									if (!strcmp(intrfc,"rle")) printf("<option>%s (riebl)\n",intrfc_full);
									if (!strcmp(intrfc,"ple")) printf("<option>%s (pam)\n",intrfc_full);
									if (!strcmp(intrfc,"de")) printf("<option>%s (dma)\n",intrfc_full);
									if (!strcmp(intrfc,"en")) printf("<option>%s (de600)\n",intrfc_full);
									if (strcmp(intrfc,"ne") &&
									    strcmp(intrfc,"lo") && 
									    strcmp(intrfc,"rle") &&
									    strcmp(intrfc,"ple") &&
									    strcmp(intrfc,"de") &&
									    strcmp(intrfc,"ppp") &&
									    strcmp(intrfc,"sl") &&
									    strcmp(intrfc,"en")) printf("<option>%s (unknown)\n",intrfc_full);
									
									/*Wenn das if existiert wird es aus der Liste der konfig. Ifs entfernt*/
									if (IntrfcExists(confIf_base,intrfc_full)) delconfIf(&confIf_base,intrfc_full);
								}
							}
							fclose(ifavail_file);

							while (confIf_base != NULL) {
								if (DEBUG) printf("main: starte Ausgabe der eingetragenen, aber nicht vorhandenen Ifs<br>\n");
								akt_confIf=confIf_base;
								if (DEBUG) printf("main: akt_confIf: %s<br>\n",akt_confIf->intrfc);
								strcpy(intrfc_full,akt_confIf->intrfc);
								strcpy(intrfc,intrfc_full);
								intrfc_len=strlen(intrfc);
								intrfc[intrfc_len-1]='\0';
								if (DEBUG) printf("main: intrfc: %s<br>\n",intrfc);
								if (!strcmp(intrfc,"ne")) printf("<option>%s (ne2000) *\n",intrfc_full);
								if (!strcmp(intrfc,"rle")) printf("<option>%s (riebl) *\n",intrfc_full);
								if (!strcmp(intrfc,"ple")) printf("<option>%s (pam) *\n",intrfc_full);
								if (!strcmp(intrfc,"de")) printf("<option>%s (dma) *\n",intrfc_full);
								if (!strcmp(intrfc,"en")) printf("<option>%s (de600) *\n",intrfc_full);
									if (strcmp(intrfc,"ne") &&
										 strcmp(intrfc,"lo") && 
									    strcmp(intrfc,"rle") &&
									    strcmp(intrfc,"ple") &&
									    strcmp(intrfc,"de") &&
									    strcmp(intrfc,"ppp") &&
									    strcmp(intrfc,"sl") &&
									    strcmp(intrfc,"en")) printf("<option>%s (unknown) *\n",intrfc_full);
								delconfIf(&confIf_base,intrfc_full);	
							}
				printf("</select>\n"
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td align=right valign=top>\n"
						"<strong><big>IP Nummer:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"ip1\" type=text size=3 maxlength=3><big>.</big>" 
						"<input name=\"ip2\" type=text size=3 maxlength=3><big>.</big>" 
						"<input name=\"ip3\" type=text size=3 maxlength=3><big>.</big>" 
						"<input name=\"ip4\" type=text size=3 maxlength=3>\n" 
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Netzmaske:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"nm1\" type=text size=3 maxlength=3><big>.</big>" 
						"<input name=\"nm2\" type=text size=3 maxlength=3><big>.</big>" 
						"<input name=\"nm3\" type=text size=3 maxlength=3><big>.</big>" 
						"<input name=\"nm4\" type=text size=3 maxlength=3>\n" 
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Hardware-Adresse (nur bei Rieblkarten):</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"hw1\" type=text size=2 maxlength=3><big>:</big>" 
						"<input name=\"hw2\" type=text size=2 maxlength=3><big>:</big>" 
						"<input name=\"hw3\" type=text size=2 maxlength=3><big>:</big>" 
						"<input name=\"hw4\" type=text size=2 maxlength=3><big>:</big>" 
						"<input name=\"hw5\" type=text size=2 maxlength=3><big>:</big>" 
						"<input name=\"hw6\" type=text size=2 maxlength=3>\n" 
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td valign=top align=right>\n"
						"<strong><big>Aktion:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<select name=\"action\" size=2>\n"
							"<option selected>konfigurieren\n"
							"<option>entfernen\n"
						"</select>\n"
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td colspan=2>\n"
						"<ul>\n"
						"<li><strong>Leider wird bei den Riebl-Netzwerk-Karten (VME und Megabus) ein Teil der Hardware-Adresse"
						" im RAM der Karte gespeichert, bei defekter oder leerer Batterie ist es deswegen notwendig beim Booten"
						" die Hardware-Adresse passend zu setzen. Es soll auch Karten geben, bei denen das Ram nicht"
						" batteriegepuffert ist.</strong><br>\n"
						"<li><strong>Es werden nur Netzwerkanschl&uuml;sse angezeigt, f&uuml;r die in \"C:\\MULTITOS\" ein"
						" passender Treiber vorhanden ist (.xif). Wenn z.B. mehrere ne2000-Karten betrieben werden sollen,"
						" so muss der Treiber mehrfach unter verschiedenem Namen im MULTITOS-Verzeichnis sein</strong><br>\n"
						"<li><strong>Wenn der Name des Anschlusses in der Auswahl mit einem \"*\" markiert ist, dann ist dieser"
						" Anschlu&szlig; zwar konfiguriert, aber dem System nicht bekannt (Treiber entfernt, Hardware entfernt)</strong><br>\n"
					   "<li><strong>Eintragen:</strong>Notwendig ist die IP-Nummer (s. Dokumentation).<br>\n"
						"</ul>\n"
					"</td>\n"
				"</tr>\n"
			"</table>\n"
			"<p>\n"
			"<input type=submit value=\"Aktion ausf&uuml;hren\">\n"
			"</form>\n");
   printf("<hr>\n");
	printf("</center>\n");
								
	print_confif();
	
	if (DEBUG) printf("Nach der Ausgabe der Tabelle<br>\n");
	
	/*Tail gibt das bei allen Seiten gleiche Ende der HTML-Anzeige aus*/
	tail();
	
	return 0;
}
