/******************************************************************************
* Dieses Programm dient zum Auslesen  der Informationen in                    *
* /etc/passwd mithilfe eines cgi-faehigen web-servers und eines Web-Browsers  *
******************************************************************************/

/* Die Includes werden gemacht */
/*---------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <support.h>
#include "util.h"

/* print_users() oeffnet /etc/passwd und gibt den Inhalt als HTML-Tabelle aus*/
/*---------------------------------------------------------------------------*/

void print_users(void) {
	FILE 					*passwd_file; 		  /* file-handle fuer /etc/passwd */
	char					host[HOSTNAME_LEN]; /* Hier wird der mit gethostname()
	                                         ermittelte Hostname gespeichert */
	int  					dummy;              /* Wird verwendet wenn ein Funktions-
	                                         ergebnis uninteressant ist */
	char					buf[MAXLINE];		  /* Hier wird eine aus /etc/passwd
	                                         gelesene Zeile gespeichert */
	char					*buf_ptr;			  /* Pointer, der beim zerlegen von buf
	                                         benoetigt wird */
	int					i;                  /* Eine Laufvariable fuer diverse 
														  Schleifen */
	int					j;						  /* Eine 2. Laufvariable */
	char					uid_str[10];		  /* Buffer zum zwischenspeichern der
														  uid vor der Konvertierung */
	char					gid_str[10];		  /* Buffer zum zwischenspeichern der
														  gid vor der Konvertierung */
	char					username[32];		  /* Buffer fuer Username */
	int  					uid;					  /* User-ID als Zahl nach der 
	                                         Konvertierung */
	int   				gid;					  /* Group-ID als Zahl nach der 
	                                         Konvertierung */
	char					gecos[255];			  /* In diesem String werden User-
	                                         Infos abgelegt */
	char  				homedir[255];		  /* Der Pfad zum homedir des Users */
	
	char  				shell[255];			  /* Der Pfad zur Loginshell des
	                                         Users */
	char					dummy_str[255];	  /* dummy_str */
	
	if (!(passwd_file=fopen(PASSWD_NAME,"r"))) {
		printf("<center><strong>Fehler beim oeffnen von /etc/passwd zum lesen der
		        Benutzerdaten</strong></center>\n");
		return;
	}
	dummy=gethostname(host,HOSTNAME_LEN);
	/*Die HTML-Tabelle wird erstellt*/
	printf("<center><h2>Bekannte Benutzer auf %s</h2>\n",host);
	printf("<table border>\n");
	
	/*Tabellenberschriften*/
	printf("<tr>\n");
		printf("<td>\n");
			printf("<strong>Benutzer-<br>name</strong>\n");
		printf("</td>\n");
		printf("<td>\n");
			printf("<strong>Benutzer-<br>nummer</strong>\n");
		printf("</td>\n");
		printf("<td>\n");
			printf("<strong>Gruppen-<br>nummer</strong>\n");
		printf("</td>\n");
		printf("<td>\n");
			printf("<strong>voller Name</strong>\n");
		printf("</td>\n");
		printf("<td>\n");
			printf("<strong>Home Directory</strong>\n");
		printf("</td>\n");
		printf("<td>\n");
			printf("<strong>Shell</strong>\n");
		printf("</td>\n");		
	printf("</tr>\n");
	
	/*Die Benutzer werden eingetragen*/
	
	do{

		/*Einlesen einer Zeile, entspricht einem User*/
		fgets(buf,MAXLINE,passwd_file);

		if (!feof(passwd_file)){
			/*Neue Tabellenzeile einfuegen*/
			printf("<tr>");

   		/*Der Username wird ausgelesen*/
			getword(username,buf,':');
			printf("<td>%s</td>",username);

			/*Das Passwort wird uebersprungen*/
			getword(dummy_str,buf,':');
		
			/*Die User-ID wird ausgelesen*/
			getword(uid_str,buf,':');
			printf("<td>%s</td>",uid_str);

			/*Die Group-ID wird ausgelesen*/
			getword(gid_str,buf,':');
			printf("<td>%s</td>",gid_str);

			/*Gecos wird ausgelesen*/
			getword(gecos,buf,':');
			printf("<td>%s</td>",gecos);


			/*Das homedir wird ausgelesen*/
			getword(homedir,buf,':');
			printf("<td>%s</td>",homedir);


			/*Die shell wird ausgelesen*/
			getword(shell,buf,':');
			printf("<td>%s</td>",shell);

			printf("</tr>\n");
		
		}

	}while (!feof(passwd_file));
	
	/*Die Tabelle wird beendet*/
	printf("</table></center>\n");
	fclose(passwd_file);
}


/* In main wird die HTML-Ausgabe initialisiert und alles gesteuert */
/*---------------------------------------------------------------------------*/

int main()
{
	/*Die Menues etc, die ueberall gleich sind werden ausgegeben*/
	header(BENUTZER,"Benutzer l&ouml;schen&nbsp;/ hinzuf&uuml;gen&nbsp;/ &auml;ndern");
	
	/*Das Eingabeformular fuer Benutzerdaten wird ausgegeben*/
	printf("<center>\n"
			 "<form action=\"/admin-bin/user_man.html\" method=post>\n"
			 "<table border>\n"
				"<tr>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Benutzername:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"username\" type=text size=12 maxlength=32>\n"
					"</td>\n"
					"<td align=right valign=top>\n"
						"<strong><big>BenutzerNr:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"userid\" type=text size=5 maxlength=5>\n" 
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td align=right valign=top>\n"
						"<strong><big>GruppenNr:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"group\" type=text size=5 maxlength=5>\n" 
					"</td>\n"
					"<td align=right valign=top>\n"
						"<strong><big>voller Name:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"fullname\" type=text size=12 maxlength=255>\n" 
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Passwort:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"password\" type=password size=10 maxlength=15>\n" 
					"</td>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Passwort (Wdh.)</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"vpassword\" type=password size=10 maxlength=15>\n" 
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td valign=top align=right>\n"
						"<strong><big>Shell:</big></strong>\n"
					"</td>\n"
					"<td>\n"
						"<select name=\"shell\" size=3>\n"
							"<option selected>default\n"
							"<option>naes\n"
							"<option>tcsh\n"
							"<option>bash\n"
							"<option>csh\n"
							"<option>ash\n"
						"</select>\n"
					"</td>\n"
					"<td valign=top align=right>\n"
						"<strong><big>Aktion:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<select name=\"action\" size=3>\n"
							"<option selected>eintragen\n"
							"<option>entfernen\n"
							"<option>aktualisieren\n"
						"</select>\n"
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td colspan=4>\n"
						"<ul>\n"
						"<li><strong>Eintragen:</strong> Notwendig ist nur der Benutzername, bei"
						" den anderen Feldern werden dann Standardwerte verwendet. Um in der"
						" Standardgruppe \"user\" eingetragen zu werden muss die Gruppennummer"
						" \"100\" verwendet werden.<br>\n"
						"<li><strong>Entfernen:</strong> Es wird nur der Benutzername"
						" beachtet.<br>\n"
						"<li><strong>Aktualisieren:</strong> Au&szlig;er dem Benutzernamen"
						" d&uuml;rfen hier nur die Felder belegt werden, die ge&auml;ndert"
						" werden sollen!<br>\n"
						"</ul>"
					"</td>\n"
				"</tr>\n"
			"</table>\n"
			"<p>\n"
			"<input type=submit value=\"Aktion ausf&uuml;hren\">\n"
			"</form>\n");
   printf("<hr>\n");
								
	/*print_users erstellt aus /etc/passwd eine HTML-Tabelle
	  und zeigt die eingetragenen Benutzer an*/
	print_users();
	
	printf("</center>\n");
	
	/*Tail gibt das bei allen Seiten gleiche Ende der HTML-Anzeige aus*/
	tail();
	
	return 0;
}
