/*
 * lpspool.h: definitions for lpspool.c
 */

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <osbind.h>
#include <basepage.h>
#include <mintbind.h>
#include <signal.h>
#include "atarierr.h"

#ifndef XDD
#include <minimal.h>
#endif

/*
 * We eventually install more than one spooler depending on the /etc/printcap
 * file, so we need an array for the printers...
 */

#define MAX_PRINTERS 128

struct printerinfo {
	char name[76]; /* We store the full name (U:\pipe\<printername> here */
};
