/*************************************************************/
/* newgrp (C) 1998 T. Lang                                   */
/* Replacement for the - in MiNTOS missing - command newgrp. */
/* Compile with "gcc -o newgrp newgrp.c"                     */
/*************************************************************/
#include <stdio.h>
#include <grp.h>
#undef setegid
#undef seteuid
#include <mintbind.h>
#define seteuid(e) \
	({ \
		int error = 0; \
		if (Pgetuid() != Pgeteuid()) { \
			error = Psetreuid(Pgeteuid(), Pgetuid()); \
			if (!(error<0)) error = Psetreuid(Pgeteuid(), -1); \
		} \
		if (!(error<0) && (Pgetuid() == (e))) { \
			error = Psetreuid((e),Pgetuid()); \
			if (!(error<0)) error = Psetreuid(Pgeteuid(), -1); \
		} else \
			error = Psetreuid(-1, (e)); \
		error; \
	})
#define setegid(e) \
	({ \
		int error = 0; \
		if (Pgetgid() != Pgetegid()) { \
			error = Psetregid(Pgetegid(), Pgetgid()); \
			if (!(error<0)) error = Psetregid(Pgetegid(), -1); \
		} \
		if (!(error<0) && (Pgetgid() == (e))) { \
			error = Psetregid((e),Pgetgid()); \
			if (!(error<0)) error = Psetregid(Pgetegid(), -1); \
		} else \
			error = Psetregid(-1, (e)); \
		error; \
	})

int main(int argc, char *argv[])
{
	struct group *grp;

	if ((argc != 3) || (argv[2][0]==0)) {
		printf("Useage: grpexec <prog> <groupname>\r\n");
		return 1;
	}
	if (!(grp = getgrnam(argv[2]))) {
		printf("unknown group\r\n");
		return 1;
	}
	if (!setegid(grp->gr_gid))
		return (system(argv[1]));
	else
		return 1;
}
